(defun xrlist( / fostat oldcmd olderr blayer datlst blnams blname basent ntnsel datlst)

	(setq	basent	T
		fostat	nil
		olderr 	*error*
	)

	(defun *error* (msg)
		(princ "\nXrlist error")
		(command "undo" "e")
		(setq *error* olderr)
		(princ)
	)
	
	(command "undo" "be")
	(setq ucntr 0)
	(setvar "cmdecho" 0)
	(princ "\nSelect entity to list: ")
	(while (setq ntnsel (nentsel))
		(setq datlst nil)
		(if (equal ntnsel "Undo")
			(progn
				(command "undo" "1")
				(setq ucntr (1- ucntr))
			)
			(progn
				(setq blayer nil) 
				(addata (car ntnsel))
				(if (setq blnams (cadddr ntnsel))
					(foreach blname blnams
						(addata blname)
					)
				)
				(setq dcl_id (load_dialog "xrlist"))
				(if (not (new_dialog "xrlist_dlg" dcl_id))(exit))
				(action_tile "accept" "(done_dialog 1)")
				(action_tile "cancel" "(done_dialog 0)")
				(action_tile "help" "(do_xrlist_help)")
				(action_tile "freeze" "(do_freeze)")
				(start_list "data_box")
				(mapcar 'add_list (reverse datlst))
				(end_list)
				(set_tile "clayer" (strcat "Current layer: " (getvar "clayer")))
				(if blayer
					(set_tile "fostat" (strcat "Base layer: " blayer))
				)
				(if (= blayer (getvar "clayer"))
					(mode_tile "freeze" 1)
				)
				(setq dialog_value (start_dialog))
				(if (= 1 dialog_value)
					(if(= fostat "F")
						(progn
							(command "layer" "f" blayer "")
							(setq ucntr (1+ ucntr))
						)
					)
				)
			)
		)
		(if (> ucntr 0)
			(progn
				(initget 128 "Undo")
				(princ "\nSelect next entity to list, \"Undo\" to undo last or [ENTER] to exit: ")
			)
			(princ "\nSelect next entity to list or [ENTER] to exit: ")
		)
	)
	(if dcl_id
		(unload_dialog dcl_id)
	)
	(command "undo" "e")
	(setq *error* olderr)
	(princ)
)  

(defun addata(ename / etype edata datstr strlst ecolor )
	(if (setq edata (entget ename))
		(progn
			(setq etype (cdr (assoc 0 edata)))
			(setq datstr(strcat(if basent(progn(setq basent nil)"   BASE ENTITY: ")	"   PART OF: ")
				(cond
					((= "INSERT" etype)
 						(if(= 0 (logand 4 (cdr (assoc 70 (tblsearch "BLOCK" (cdr (assoc 2 edata)))))))
							(strcat "INSERT named " (cdr (assoc 2 edata)))
							(strcat "XREF named " (cdr (assoc 2 edata)))
						)
      					)
					((= "TEXT" etype)(strcat "TEXT in style " (if (cdr (assoc 7 edata))(cdr (assoc 7 edata)) "STANDARD")))
					((= "ATTRIB" etype)(strcat "ATTRIB in style " (if (cdr (assoc 7 edata))(cdr (assoc 7 edata))"STANDARD")", with tag "(cdr (assoc 2 edata))))
					(T etype)
     				)
				", on layer "
				(if blayer (cdr (assoc 8 edata))(setq blayer (cdr (assoc 8 edata))))
				", in "
     				(if (cdr (assoc 6 edata))(cdr (assoc 6 edata))"BYLAYER")
     				" linetype, in "
				(if (setq ecolor (cdr (assoc 62 edata)))
					(cond
						((= ecolor 256) "BYBLOCK")
						((= ecolor 0) "BYLAYER")
						((= ecolor 1) "RED")
						((= ecolor 2) "YELLOW")
						((= ecolor 3) "GREEN")
						((= ecolor 4) "CYAN")
						((= ecolor 5) "BLUE")
						((= ecolor 6) "MAGENTA")
						((= ecolor 7) "WHITE")
						(T (itoa ecolor))
					)
					"BYLAYER"
				)
     				" color. "
			)	)
   			(setq strlst (wrdwrp datstr 53))
			(if strlst
				(foreach substrng (reverse strlst)
					(setq datlst (cons substrng datlst))
				)
			)
		)
	)
)

(defun helpomat(hlplst hlpttl)
	(if (not (new_dialog "help_box" dcl_id))(exit))
	(start_list "list_box")
	(mapcar 'add_list hlplst)
	(end_list)
	(set_tile "title" hlpttl)
	(start_dialog)
)

(defun do_freeze()
	(cond
		((null fostat)(setq fostat "F")(set_tile "fostat" (strcat "Base layer: " blayer " frozen.")))
		((= fostat "F")(setq fostat nil)(set_tile "fostat" (strcat "Base layer: " blayer)))
		((= fostat "O")(setq fostat "FO")(set_tile "fostat" (strcat "Base layer: " blayer " off/frozen.")))
		((= fostat "FO")(setq fostat "O")(set_tile "fostat" (strcat "Base layer: " blayer " off.")))
 	)
)

(defun do_xrlist_help()
	(helpomat
		(list 	"---------------------------------------------------------"
			"xrlist help"
			"---------------------------------------------------------"
			"     Xrlist is a program that tells you information about"
			" nested entities; that is, entities that are part of"
			" other entities, as a LINE entity might be a component"
			" of an INSERT, which in turn might be a component of"
			" an XREF.  If you want, for example, to freeze that"
			" LINE's visibilty, you might not know what layer to freeze."
			" If you LIST the LINE by picking it, LIST will tell you "
			" the name of the XREF and the layer it is on, but you"
			" still won't know what layer the LINE itself is on."
			" Xrlist tells you all the various nested items and their"
			" layers, without forcing you to exit the drawing you're"
			" in and opening the XREF drawing, or exploding the block."
			"---------------------------------------------------------"
		)
  		" xrlist Help "
 	)
)

(defun wrdwrp(string length / stpart stlist scount )
	(setq stlist nil)
	(while (and (/= "" string)(= " " (substr string (strlen string))))
		(setq string (substr string 1 (1- (strlen string))))
 	)
	(if (or (= string "")(<= length 0))
  		nil
		(progn
   			(while (> (strlen string) length)
				(setq scount (1+ length) stpart nil)
				(while (and (null stpart)(> (setq scount (1- scount)) 1))
					(if (= " " (substr string scount 1))
						(setq 	stpart (substr string 1 (1- scount))
            						string (substr string (1+ scount))
      						)
	     				)
    				)
    				(if stpart
					(setq stlist (cons stpart stlist))
					(setq 	stlist (cons (substr string 1 length) stlist)
						string (substr string (1+ length))
					)
    				)
				(while (and (/= "" string)(= " " (substr string 1 1)))
					(setq string (substr string 2))
				)
	   		)
			(if (/= "" string)
				(setq stlist (cons string stlist))
			)
	  	)
	)
)
(princ)    
